unit Flag;
interface
uses
   Objects,
   Morphing,
   GRect,
   General, Common, Startup,
   Copy, GraphFns;

procedure HideFlag;
procedure ShowFlag;

implementation

const
   FlagX =         3;
   FlagY =         200-64;
   FlagW =         56;
   FlagH =         28;
   FlagSX =        3;
   FlagSY =        3;

var
   i               :Integer;

{$L flag}
procedure _Flag; external;

{$L flagpole}
procedure _FlagPole; external;

{$L sin}
procedure _Sin; external;

type
   TSin =          Array [0..90] of ShortInt;
const
   SinArray        :^TSin = @_Sin;

function  QSin(x                       :Integer) :Integer;
var
   xn, r           :Integer;
begin
   xn:=Abs(x) mod 360;
   case xn of
      0..90:    r:= SinArray^[xn];
      91..180:  r:= SinArray^[180-xn];
      181..270: r:=-SinArray^[xn-180];
      271..360: r:=-SinArray^[360-xn];
   end;
   if x>=0 then QSin:=r else QSin:=-r;
end;

procedure FlagStep(Image               :PGPoint);
begin
   for i:=1 to Image^.Y do ShiftX[i]:=QSin((i+Timer)*7) div 48;
   for i:=1 to Image^.X do ShiftYOfs[i]:=320*(QSin((i+Timer)*7) * (Image^.X+Image^.X shr 2-i) div (Image^.X*48));
end;

procedure HideFlag;
begin
   CopyArea(FlagX-FlagSX, FlagY+3-FlagSY, FlagW+2*FlagSX, FlagH+2*FlagSY, PtrRec(BackPtr).Seg, PtrRec(FinalBuffer).Seg);
end;

procedure ShowFlag;
var
   SaveShiftX      :TShiftX;
   SaveBuffer      :Pointer;
begin
   SaveShiftX:=ShiftX; SaveBuffer:=BufferPtr;

   FlagStep(@_Flag);
   Morph(FlagX +FlagW shr 1, FlagY+3 +FlagH shr 1, @_Flag, Seg(FinalBuffer^));

   BufferPtr:=FinalBuffer;
   PutBlock(FlagX, FlagY, @_FlagPole);
   ShiftX:=SaveShiftX; BufferPtr:=SaveBuffer;
end;

end.
